<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 2.5: Arithmetic Operators</title>
<link href="sx5d.html" rev=precedes>
<link href="sx5f.html" rel=precedes>
<link href="sx5.html" rev=subdocument>
</head>
<body>
<H2>section 2.5: Arithmetic Operators</H2>

page 41
<p>Keep in the back of your mind somewhere
the fact
that the behavior of the <TT>/</TT> and <TT>%</TT> operators 
is not precisely defined for negative operands.
This means that <TT>-7 / 4</TT> might be -1 or -2,
and <TT>-7 % 4</TT> might be -3 or +1.
The difference won't matter for the simple programs we'll be 
writing at first,
but eventually you'll get bit by it if you don't remember it.
</p><p>An additional arithmetic operation you might be wondering about
is exponentiation.
Some languages have an exponentiation operator
(typically <TT>^ or </TT><TT>**</TT>),
but C doesn't.
</p><p>The term ``precedence'' refers to how ``tightly'' operators bind to 
their operands (that is, to the things they operate on).
In mathematics, multiplication has higher precedence than 
addition, so <TT>1 + 2 * 3</TT> is 7, not 9.
In other words, <TT>1 + 2 * 3</TT> is equivalent to <TT>1 + (2 * 3)</TT>.
C is the same way.
</p><p>The term ``associativity'' refers to the grouping when two or 
more operators of the same precedence participate next to each 
other in an expression.
When an operator (like subtraction) associates ``left to right,''
it means that <TT>1 - 2 - 3</TT> is equivalent to <TT>(1 - 2) - 3</TT>
and gives -4, not +2.
</p><p>By the way,
the word ``arithmetic''
as used in the title of this section
is an adjective, not a noun,
and it's pronounced differently than the noun:
the accent is on the third syllable.
</p><hr>
<p>
Read sequentially:
<a href="sx5d.html" rev=precedes>prev</a>
<a href="sx5f.html" rel=precedes>next</a>
<a href="sx5.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
